#ifndef __timestat__
#define __timestat__

/*!
 *  @brief ַ¬
 */
#define RDTSC(x) __asm__ __volatile__ ("rdtsc" : "=A" (x))
// #define CPU_CLOCK 1266272000. // Hz
#define CPU_CLOCK 3215534000. // Hz
static double invClock = 1./CPU_CLOCK;
static double invClockNsec = 1.e9/CPU_CLOCK;

//#define TS_COUNT 100
//#define PERIOD 20000
//#define PERIOD 2000

static double getTime(void)
{
  struct timeval tv;
  gettimeofday(&tv, NULL);
  return (tv.tv_sec + (double)tv.tv_usec*1e-6);
}

void 
static statistics(char* str, double tm)
{
  static int cnt;
  static double tmSum; // 
  static double tm2Sum; // tm22ι
  static double max = 0.0;
  static double min = 1.0e10;;
  static int first = 0;

  if (max < tm)
    max = tm;
  else if (min > tm)
    min = tm;

  tmSum += tm;
  tm2Sum += tm * tm;

  if (cnt++ % TS_COUNT == 0) {
    if (first == 0) {
      first = 1;
    } else {
      double tmMean, tmStd;
      tmMean = tmSum / (double)TS_COUNT;
      tmStd = sqrt(tm2Sum / (double)TS_COUNT - (tmMean * tmMean));
      
      std::cout << str;
      std::cout << "\t" << tm << ", max=" << max << ", min=" << min << "\n";
      std::cout << "\t" << PERIOD*1.e-6 << "[s], mean=" << tmMean << ", std=" << tmStd << std::endl;
    }
    tmSum = 0.0;
    tm2Sum = 0.0;
    max = 0.;
    min = 1.e10;
  }
}

#endif

