// -*- C++ -*-
#ifndef __GRAPHWINDOW_H__
#define __GRAPHWINDOW_H__

extern "C" {
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <unistd.h>
#include <pthread.h>
}

#include <iostream>  // tmp
#include <string>
#include <deque>

#include <assert.h>

//#define CROSS

#define POINT_NUM 5  // size of dots

#define MAX_DATA 64  // 8 ܿ
#define PLOT_WIDTH 3

using namespace std;

class GraphWindow
{
public:
  enum TGT {
//     F1 = 0,
//     F2 = 1,
//     F3 = 2,
//     M1 = 3,
//     M2 = 4,
//     M3 = 5,
//     TIMESCALE = 10,
//     D1 = 0,
//     D2 = 1,
//     D3 = 2,
//     D4 = 3,
//     D5 = 4,
//     D6 = 5,
//     D7 = 6,
//     D8 = 7,
//     D9 = 8,
//     D10 = 9,
//     D11 = 10,
//     D12 = 11,
//     D13 = 12,
//     D14 = 13,
//     D15 = 14,
    TIMESCALE = 100,
  };
  
private:
  pthread_t mlthread;
  pthread_mutex_t* mlmutex;

  XPoint fig[POINT_NUM];

protected:
  struct point {
    TGT    tgt;
    double time;
    double orig_time;
    double value;
    int x;             // ploted position
    int y;             // ploted position
  };

  struct plot_data {
    double max;
    double min;
    GC     gc;
    bool   use;
    deque<point> pos;
    int    graphId;
  };

  Display* display;
  Window   win;
  GC       gc;
  XEvent   event;
  KeySym   key;
  XSizeHints* size_hints;

  int win_width, win_height;          // window size
  int graph_height;                   // graph size
  int y_offset;                       // y-axis offset
  const int win_pos_x, win_pos_y;     // window position

  bool dualGraph;
  bool forceGraph;
  bool momentGraph;

  string window_name;
  
  plot_data data[MAX_DATA];
  int    x_margin, y_margin;  // graph area margin
  double timescale;
  double orig_time;       // time origin of graph
  bool recycle;
  bool fileoutput;
  string plotColors[MAX_DATA];
  int erase_pixels;

  char m_gtitle1[256];
  char m_gtitle2[256];
  
  void initialize(void);
  int initGraphWindow(void);
  void drawAxis(void);
  void drawDot(int tgt, int x, int y);
  void drawLine(int x1, int y1, int x2, int y2, GC& gc);
  unsigned long setColor(char* cn);

  void getPlotPoint(int tgt, double time, double value, int& x, int& y);
  bool eraseArea(int tgt);
  bool eraseData(int tgt, bool rewind);
  void plotDot(int tgt, bool rewind = false);
  void drawAll(bool calc = false);
  void plotAll(int tgt, bool calc = false);
  void reset(void);
  void setRange(double val, int f, int t);
  void calcGraphParameters(void);
#if 0
  void draw(void);
#endif

  static void* threadFunc(void *arg);
  void eventProcessFunc(void);

public:
  GraphWindow(const char*, int, int);
  virtual ~GraphWindow();

  void ShowWindow(void);
  void HideWindow(void);

  // axis = X ΤȤ a Τ߻֤Ȥƻ
  // axis = Y ΤȤ a,b ϰϤȤƻ
  void SetAxis(TGT target, double a, double b = 0.0) {}
  void SetDot(TGT target, double time, double value);
  void SetData(double time, float value[MAX_DATA]);
  void SetWindowName(string name) {} // not implemented
#if 1
  void Draw(void);
#endif
  void Reset(void);
  void SetGraphParameters(int gid, char*);
  void SetRange(int port, double min, double max);
  void SetRange2(int port, double min, double max, int graphId);
  void SetGraphRange(int gid, double min, double max);
//   void SetForceRange(double val);
//   void SetMomentRange(double val);
  void SetTimescale(double val) {timescale = val;}
  bool IsReqestFileOutput(void);
};
#endif
// SetDot  褹򥻥åȤơDraw 褹
