#include <iostream>
#include <fstream>
#include <string>
#include "Interp.h"

using namespace std;

Interp::Interp(dataLogger* dtl)
  : datalogger(dtl)
{
  printUsages();

  // create thread
  if (pthread_create(&mlthread, NULL, threadFunc, this)) {
    cerr << "ERROR : Creating thread failed." << endl;
    exit(1);
  }
  
}

void* Interp::threadFunc(void* arg) {
  static_cast<Interp*>(arg)->interpLoop();
  return 0;
}

void Interp::printUsages(void)
{
  cout << "Datalogger usages\n";
//    cout << " start or on : datalogger start.\n";
//    cout << " stop or off: datalogger stop.\n";
  cout << " disp[lay] : display information ON/OFF(toggle).\n";
  cout << " disp[lay] [dsec] : display info with dsec interval (dsec/10 sec.).\n";
  cout << " file [filename] [number of data] : log to file.\n";
  cout << " range [port#] [min] [max]: set display data range.\n";
#ifdef ART
  cout << " peri[od] period : change period of art_enter (period usec.).\n";
#endif
  cout << " press Ctrl+c to quit program." << endl;
}

char Interp::remove_space(void)
{
  char c;
  do {
    c = cin.get();
  } while (c != '\n' && isspace(c));
  cin.unget();
  return c;
}

void Interp::interpLoop(void)
{
  string line, token;
  string filename = "default_log.txt";
  int    data_num = 5000;
  int  output_time = 10;
  char   c;
  
  bool svr_stat = false;
  bool disp_stat = false;

  datalogger->displayOutput(disp_stat, output_time);
  
  while (1) {
    cout << "> ";
    cin >> token;
//     if (!token.compare("start") || !token.compare("on")) {
//       if (!svr_stat) {
// 	cout << "datalogger start." << endl;
// 	datalogger->rtc_start();
// 	svr_stat = !svr_stat;
//       }
//     } else if (!token.compare("stop") || !token.compare("off")) {
//       if (svr_stat) {
// 	cout << "datalogger stop." << endl;
// 	datalogger->rtc_stop();
// 	svr_stat = !svr_stat;
//       }
//     } else if (!token.compare("file")) {
    if (!token.compare("file")) {
      c = remove_space();
      if (isalpha(c)) {
	cin >> filename;
	c = remove_space();
	if (c != '\n')
	  cin >> data_num;
      } else if (c != '\n') {
	cout << "Usage: file [filename] [data_num]" << endl;
	goto FLASH;
      }
      cout << "Log to file: " << filename << ", " << data_num << endl;
//        datalogger->fileOutput(filename.c_str(), data_num);
      datalogger->setLogData(filename.c_str(), data_num);
    } else if (!token.find("disp")) {
      c = remove_space();
      if (isdigit(c)) {
	cin >> output_time;
	disp_stat = true;
	cout << "Display ON and " << output_time/10. << "[sec]" << endl;
	datalogger->displayOutput(disp_stat, output_time);
      } else if (c != '\n') {
	cout << "Usage: disp [interval(dsec)]" << endl;
	goto FLASH;
      } else {
	disp_stat = !disp_stat;
//  	cout << "Display on/off toggle" << endl;
	datalogger->displayOutput(disp_stat, output_time);
      }	
    }
    // add "range" K.Kitagaki 040611
    else if (!token.find("range")) {
//       c = remove_space();
      int port_number;
      float min, max;
//       if (isdigit(c)) {
      port_number = 0; // for compile
	min = 0.0;  // for compile
	max = 10.0; // for compile
	cin >> port_number >> min >> max;
	cout << "Change range to [" << min << " " << max << "]" << endl;
	datalogger->setRange(port_number, min, max);
//       } else
// 	cout << "Usage: range port# min max" << endl;
     }
#ifdef ART
    else if (!token.find("peri")) {
      c = remove_space();
      int period_num;
      if (isdigit(c)) {
	cin >> period_num;
	cout << "Change period to " << period_num << endl;
	datalogger->setPeriod(period_num);
      } else
	cout << "Usage: period period(usec)" << endl;
    }
#endif
    else if (!token.compare("help")) {
      printUsages();
    }

  FLASH:

    do {
      c = cin.get();
      //      cout << hex << static_cast<int>(c) << dec << endl;
    } while (c != '\n');

  }
  
//   if (svr_stat)
//     datalogger -> rtc_stop();
}

#if 0
bool
read_data_file(string filename, int data_num, double* s, double* l)
{
  ifstream inf(filename.c_str());
  string dummy;

  if(!inf)
    return false;
  for (int i = 0; i < data_num; i++) {
    inf >> s[i] >> l[i];
    s[i] -= s[0];
    l[i] -= s[0];
    getline(inf, dummy);
    if(!inf.good())
      return false;
  }
  return true;
}
#endif
