// -*- C++ -*-
/*!
 * @file dataLoggerComp.cpp
 * @brief Standalone component
 * @date $Date$
 *
 * $Id$
 */

#include <rtm/Manager.h>
#include <iostream>
#include <string>
#include "dataLogger.h"

string configurationFileName;
GraphProperty graphProperty;

void MyModuleInit(RTC::Manager* manager)
{
  dataLoggerInit(manager);
  RTC::RtcBase* comp;

  // Create a component
  comp = manager->createComponent("dataLogger");

  return;
}

int main (int argc, char** argv)
{
  if (argc != 4) {
    cout << "usage: dataLoggerComp -f rtc.conf <configuration_file>.conf" << endl;
    exit(0);
  } else {
    configurationFileName = argv[3];
    //    cout << configurationFileName.c_str() << endl;
    argc = 3;
  }

  RTC::Manager* manager;
  manager = RTC::Manager::init(argc, argv);

  // Initialize manager
  manager->init(argc, argv);

  // Set module initialization proceduer
  // This procedure will be invoked in activateManager() function.
  manager->setModuleInitProc(MyModuleInit);

  // Activate manager and register to naming service
  manager->activateManager();

  // run the manager in blocking mode
  // runManager(false) is the default.
  manager->runManager();

  // If you want to run the manager in non-blocking mode, do like this
  // manager->runManager(true);

  return 0;
}
