#ifndef _WRAP2SHAREDMEM_H__ 
#define _WRAP2SHAREDMEM_H__
// char = 1 byte (8 bit)
// int = float = 4 byte (32 bit)
// double = 8 byte (64 bit)
#define MEM_SZ 10240
#define KEY0_R1 2100
#define KEY0_R2 2200
#define KEY0_W1 2300
#define KEY0_W2 2400

#define KEY1_R1 2500
#define KEY1_R2 2600
#define KEY1_W1 2700
#define KEY1_W2 2800

class SHARED_MEM{
 private:
  char *shm0_r1, *shm0_r2, *shm0_w1, *shm0_w2;
  char *shm1_r1, *shm1_r2, *shm1_w1, *shm1_w2;
  int  shmid0_r1, shmid0_r2, shmid0_w1, shmid0_w2;
  int  shmid1_r1, shmid1_r2, shmid1_w1, shmid1_w2;
 public:
  void InitSharedMemClient(int);
  void ClearSharedMem(int);
};


struct shared_mem_data_write {
  long  switch_flag;
  long  command_flag[6];
  long  arm_no;
  long  redundant_mode;
  long  redundant_order;
  float sethome_ang[7];
  float setready_ang[7];
  float setbase_frame[12];
  float setwrist_frame[12];
  float settool_frame[12];
  float put_reference_conf_arm_frame[12];
  float put_reference_conf_arm_nowait_frame[12];
  float put_reference_vel_arm_vel[6];
  float put_reference_ang_arm_ang[7];
  float put_reference_ang_arm_nowait_ang[7];
  float put_reference_ang_vel_arm_ang[7];
  float put_reference_conf_frame[12];
  float put_reference_conf_nowait_frame[12];
  float put_reference_vel[6];
  float put_reference_ang[7];
  float put_reference_ang_nowait_ang[7];
  float put_reference_ang_vel[7];
  float set_control_coords_frame[12];
  float set_limit_vel[6];
  float set_limit_ang_vel[7];
  float set_restrict_ang[7];

  //  float angle[7];
  //  float frame[12];
  //  float vel[7];
  //  long  flag[6];
  //  long  mv_flag[6];
  //  float vel_gain[6];
};

struct shared_mem_data_read {
  long  switch_flag;
  long  error_flag[6];
  float gethome_ang[7];
  float getready_ang[7];
  float getbase_frame[12];
  float getwrist_frame[12];
  float gettool_frame[12];
  float get_current_conf_arm_frame[12];
  float get_reference_conf_arm_frame[12];
  float get_reference_vel_arm_vel[6];
  float get_current_ang_arm_ang[7];
  float get_reference_ang_arm_ang[7];
  float get_reference_ang_vel_arm_ang[7];
  float get_current_conf_frame[12];
  float get_reference_conf_frame[12];
  float get_reference_vel[6];
  float get_current_ang[7];
  float get_reference_ang[7];
  float get_reference_ang_vel[7];
  float get_control_coords_frame[12];
  float get_limit_vel[6];
  float get_limit_ang_vel[7];



  //  float angle[7];
  //  float frame[12];
  //  float vel[7];

  //  float tip_vel[6];
  //  float tip_force[6];
  //  float tip_pos[4][4];
};



#define ERR_OK      0
#define INIT        1
#define ONSERVO     2
#define STOP        3
#define SET_HOME    5
#define GET_HOME    6
#define SET_READY   7
#define GET_READY   8
#define TERM        9

#define WAKE     11
#define SLEEP    12
#define HOME     13
#define READY    14

#define SET_BASE    21
#define GET_BASE    22
#define SET_WRIST   23
#define GET_WRIST   24
#define SET_TOOL    25
#define GET_TOOL    26

#define GET_CURRENT_CONF_ARM          31
#define GET_CURRENT_ANG_ARM           32
#define GET_CURRENT_CONF              33
#define GET_CURRENT_ANG               34

#define PUT_REFERENCE_CONF_ARM        41
#define PUT_REFERENCE_CONF_ARM_NOWAIT 42
#define GET_REFERENCE_CONF_ARM        43

#define PUT_REFERENCE_VEL_ARM         51
#define GET_REFERENCE_VEL_ARM         52

#define PUT_REFERENCE_ANG_ARM         61
#define PUT_REFERENCE_ANG_ARM_NOWAIT  62
#define GET_REFERENCE_ANG_ARM         63

#define PUT_REFERENCE_ANG_VEL_ARM     71
#define GET_REFERENCE_ANG_VEL_ARM     72

#define PUT_REFERENCE_CONF            81
#define PUT_REFERENCE_CONF_NOWAIT     82
#define GET_REFERENCE_CONF            83

#define PUT_REFERENCE_VEL             91
#define GET_REFERENCE_VEL             92

#define PUT_REFERENCE_ANG             101
#define PUT_REFERENCE_ANG_NOWAIT      102
#define GET_REFERENCE_ANG             103

#define PUT_REFERENCE_ANG_VEL         111
#define GET_REFERENCE_ANG_VEL         112

#define SET_CONTROL_COORDS            121
#define GET_CONTROL_COORDS            122
#define SET_LIMIT_VEL                 123
#define GET_LIMIT_VEL                 124
#define SET_LIMIT_ANG_VEL             125
#define GET_LIMIT_ANG_VEL             126
#define GET_STAT                      127

#define SET_RESTRICT_ANG              131
#define SET_REDUNDANT_MODE            132
#define SET_REDUNDANT_ORDER           133
#define SV_OFF                        134
#define GET_ENDEFFECTOR               135
#define SET_ENDEFFECTOR               136



#endif // _WRAP2SHAREDMEM_H__
