/********************************************************
*	                           					        *
*    MODULE NAME  : RMRC.h		             	        *
*     						                            *
*    FUNCTION     : the RMRC Method value literal       *
*     						                            *
*    CODED	      : M.Takahashi  on '98.10.23        	*
*     			         		                        *
*    MODIFIED     : Woo-Keun Yoon on 1999.01.16         *
*     						                            *
********************************************************/

//#include "pa10.h"

typedef struct
{
  /*class RMRC {*/

  /* Init.c++ */
  double DesiredAngles[14];   /* Ĺɸ */
  double angmax[7];      /* Maximum Joint Angle (rad) */
  double angmin[7];      /* Mimimum Joint Angle (rad) */
  double jvelmax[7];     /* Maximum Velocity of each joint (rad/sec) */

  /* parmrc.c++ */
  double refq[7];        /* γ */
  double refdq[7];       /* γ® */

  /* Jacoban */
  double jac[6][7];	          /* Jacobian Matrix */
  double Tdot[7];             /* ü J#*dr    */
  double Ker[7];              /* Ʊ (I-J#J)*guzai */

  /* Parameters for the new estimate function */
  double sdltangl[7];    /* Variation of each joint */
  double estfunc[7];     /* Value of estimate function	*/
  double estmax[7];	  /* Current maximum value */
  double estmin[7];	  /* Current mininum value*/
  double guzai[7];       /* estmaite funcion */
  double Kp;                  /* ɾؿη Kp */

  /* S3 Rotation from the initial position to the last */
  double	sgain;		      /* Coefficient to convert
  				                 control cycle and 1 second	*/

  int RestrictMode;		      /* Restriction mode */
  double q[14];               /*  */
  double dqR[7];              /* ® */
  double dqL[7];              /* ® */
  double dumq[7];
  double linklen[7];     /* Link Length (mm) */
  double cycle;               /* Control cycle time [sec] */
  double dr[6];
  double parminputR[6];
  double parminputL[6];
  
  double tipposition[6];

  /* initrmrc.c++ */
  //  void   InitRmrc();
  /* parmrc.c++ */
  //  int    parmrc( int );
  //  int    rmrcchk( int );
  /* jacobian.c++ */
  //  void   jacobian( int );
  //  int    Makeinv( int );
  /* estimate.c++ */
  /*  void   SetFunctionLimit();
	  void   Makeguzai();
	  void   MakeKp();
	  double CalcS3Func( double ); 
  */
} RMRC;


/****** macsro ******/
#define GOOD     0
#define SQ_MINUS 1
#define OV_LM_CY 2
#define N_CALC_INV_KM 3
#define N_CALC_INV_Jp 4
#define N_CALC_INV_S  5
#define DETER_ZERO    6
#define N_MATCH_PRM   7





