/********************************************************
*			                        		    		*
*   MODULE NAME : pa10.h	                	        *
*							                            *
*   FUNCTION    : Literal & Type Definition for PA10	*
*							                            *
*   CODED	    : M.Takahashi  on '98.10.23		        *
*							                            *
*   MODIFIED    : Woo-Keun Yoon on 1999.01.16           *
*							                            *
********************************************************/

typedef	unsigned char	UINT_8;

/*** dual arm ***/
#define RIGHT_ARM 0
#define LEFT_ARM  1

/*** Literal Definitions ***/
#define	JNTNUM	7	/* Number of Joint			*/

/* Joint Identifier */
#define	S1		0	/* 1st joint				*/
#define	S2		1	/* 2nd joint				*/
#define	S3		2	/* 3rd joint				*/
#define	E1		3	/* 4th joint				*/
#define	E2		4	/* 5th joint				*/
#define	W1		5	/* 6th joint				*/
#define	W2		6	/* 7th joint (Hand)			*/

#define	RS1		0	/* 1st joint				*/
#define	RS2		1	/* 2nd joint				*/
#define	RS3		2	/* 3rd joint				*/
#define	RE1		3	/* 4th joint				*/
#define	RE2		4	/* 5th joint				*/
#define	RW1		5	/* 6th joint				*/
#define	RW2		6	/* 7th joint (Hand)			*/
#define	LS1		7	/* 1st joint				*/
#define	LS2		8	/* 2nd joint				*/
#define	LS3		9	/* 3rd joint				*/
#define	LE1	   10	/* 4th joint				*/
#define	LE2	   11	/* 5th joint				*/
#define	LW1	   12	/* 6th joint				*/
#define	LW2	   13	/* 7th joint (Hand)			*/

#define LNKNUM	7	/* Number of Link			*/
/* Link Identifier */
#define	LNK1	0	/* S1-S2				*/
#define	LNK2	1	/* S2-S3				*/
#define	LNK3	2	/* S3-E1				*/
#define	LNK4	3	/* E1-E2				*/
#define	LNK5	4	/* E2-W1				*/
#define	LNK6	5	/* W1-W2				*/
#define	LNK7	6	/* W2-HAND				*/

/* Maximum Arm Length */
#define	MAXLENG		( (double)0.945 * (double)0.945 )

/*** for the definition of S3 gain ***/
#define	S3CASENUM	5	// Number of the rank of S3 gain

#define	S3GAIN1		0
#define	S3GAIN2		1
#define	S3GAIN3		2
#define	S3GAIN4		3
#define	S3GAIN5		4

/*** Definition of the Redandancy Control flag ***/
#define	NO_RESTRICT	    0	// Normal RMRC ( No redandant axis control )
#define	ALL_RESTRICT	1	// Restrict all joints
#define	S3_RESTRICT	    2	// Restrict only S3 joint
#define	S3_INTERPOLATE	3	// Restrict & interpolate S3 joint
#define	S3_LOCK		    4	// Fix S3 joint ( 6 Axes control )

/*** Offset from currnt S3 angle to the quadratic function limit 
 			       in case of S3_RESTRICT or S3_INTERPOLATE ***/
#define	FUNCOFFSET	degtorad( 50.0 )	// rad

#define		PAI	 3.14159265358979323846

/* Size of Jacobian Matrix      */
#define JACN        6
#define JACM        7

/* Drirection of Equivalence Rotation */
#define	ROT_POS		 1	/* angle >= 0 			*/
#define	ROT_NEG		-1	/*       <  0			*/

/*** Macro Definitions ***/
/* Degree to Radian		*/
#define		degtorad(deg)	((double)(deg)*(double)PAI/(double)180.0)
/* Radian to Degree		*/
#define		radtodeg(rad)	((double)(rad)*(double)180.0/(double)PAI)




