/********************************************************
*				                          			    *
*   MODULE NAME	: pa_err.h		            	        *
*                    							        *
*   FUNCTION  	: Error Status of the RMRC Method       *
*			      for the PA-10 Arm          	        *
*	                     						        *
*   CODED 		: M.Takahashi  on '98.10.23 	        *
*							                            *
*   MODIFIED	: Woo-Keun Yoon on 1999.01.16		    *
*                    							        *
********************************************************/

#define	NORMAL 0	    /* Normal End			*/

/*** Fetal Error Code ***/

/*
  4096  = 0x1000
  28672 = 0x7000
  65024 = 0xfe00
  130560 =0x1fe00
  130562 =0x1fe02
*/

/* Set by parmrc() */
#define	E_LENOVER	0x1000	/* Arm Length Over > 945 | 4096 */
#define	E_S1LIMOVER	0x0600	/* S1 Limit Over        	*/
#define	E_S2LIMOVER	0x0700	/* S2 Limit Over        	*/
#define	E_S3LIMOVER	0x0800	/* S3 Limit Over        	*/
#define	E_E1LIMOVER	0x0900	/* E1 Limit Over        	*/
#define	E_E2LIMOVER	0x0a00	/* E2 Limit Over        	*/
#define	E_W1LIMOVER	0x0b00	/* W1 Limit Over        	*/
#define	E_W2LIMOVER	0x0c00	/* W2 Limit Over        	*/

/*** Warning Code ***/

/* Set by parmrc() */
#define	W_S1VELOVER	0x0002	/* S1 Joint Velocity Over	*/
#define	W_S2VELOVER	0x0004	/* S2 Joint Velocity Over	*/
#define	W_S3VELOVER	0x0008	/* S3 Joint Velocity Over	*/
#define	W_E1VELOVER	0x0010	/* E1 Joint Velocity Over	*/
#define	W_E2VELOVER	0x0020	/* E2 Joint Velocity Over	*/
#define	W_W1VELOVER	0x0040	/* W1 Joint Velocity Over	*/
#define	W_W2VELOVER	0x0080	/* W2 Joint Velocity Over	*/

/* Set by painv() */







