#ifndef __EndEffector_h_
#define __EndEffector_h_

#include "DataType.h"

enum ENDEFFECTOR_TYPE {
  MUGRIPPER, WRENCHGRIPPER, NUTGRIPPER, NO_ENDEFFECTOR };

class EndEffector {
  public:
    virtual void init(void) = 0;
    virtual void setType(ENDEFFECTOR_TYPE) = 0;
    virtual void setMass(const SCALAR) = 0;
    virtual void setMomentOfInertia(const Matrix3x3) = 0;
    virtual void setCenterOfGravity(const Pos) = 0;
    virtual ENDEFFECTOR_TYPE getType(void) = 0;
    virtual SCALAR getMass(void) = 0;
    virtual void getMomentOfInertia(Matrix3x3&) = 0;
    virtual void getCenterOfGravity(Pos&) = 0;
};

#endif
