#ifndef __muGripper_h_
#define __muGripper_h_

#include "Gripper.h"
#include "EndEffectorImpl.h"

#define MU_MASS (SCALAR)0.95
#define MU_INERTIA_X (SCALAR)0.0
#define MU_INERTIA_Y (SCALAR)0.0
#define MU_INERTIA_Z (SCALAR)0.0
#define MU_CENTER_X (SCALAR)1.0
#define MU_CENTER_Y (SCALAR)0.5
#define MU_CENTER_Z (SCALAR)-55.0

/*==============================================================
	For Mu gripper
==============================================================*/
/*	status		*/
#define M_GRIPPER_STAT_CLOSE	1
#define M_GRIPPER_STAT_OPEN	2
#define M_GRIPPER_STAT_STOP	4
/*	command		*/
#define M_GRIPPER_OPEN		0
#define M_GRIPPER_CLOSE		1
#define M_GRIPPER_SLOW		2
#define M_GRIPPER_STOP		4

class MuGripper : public EndEffectorImpl, public Gripper
{
private:
    SA_ERR err;

public: 
    MuGripper();
    virtual ~MuGripper(){};
    void init(void);
    SA_ERR getError(void);
    void setError(SA_ERR);
    virtual int stat(void) = 0;
    virtual void output(int val) = 0;
    virtual void open(void) = 0;
    virtual void close(void) = 0;
    virtual void stop(void) = 0;
};

#endif
