#ifndef __nittaFts_h
#define __nittaFts_h

#include "DataType.h"
#include "FtSensorImpl.h"
#include "NittaFtsController.h"

class NittaFts : public NittaFtsController, public FtSensorImpl {
  public:
    	NittaFts(int);
    	~NittaFts(){};
	void init(const int flag);
	void calibration(int fi[6]);

	void setFilter(const int no);

	// force/torque at F/T Sensor measurment origin 
	// in F/T Sensor measurement coordinates.
	void forceAtFsInFs(DoubleVec &f);

	// force at Arm Wrist coordinates (FtsBaseCoords) origin
	// in Arm Wrist coordinates (FtsBaseCoords).
	void forceAtAwInAw(DoubleVec &f);

	// force at Arm Wrist coordinates (FtsBaseCoords) origin
	// in FtsCoords.
	void forceAtAwInFc(DoubleVec &f);

	// force at FtsCoords origin
	// in FtsCoords.
	void forceAtFcInFc(DoubleVec &f);

	void transAtFsInFs2AtAwInAw(DoubleVec&, DoubleVec&);
	void transAtAwInAw2AtFsInFs(DoubleVec&, DoubleVec&);
	void transAtAwInAw2AtAwInFc(DoubleVec&, DoubleVec&);
	void transAtAwInAw2AtFcInFc(DoubleVec&, DoubleVec&);

  private:
	
};

#endif
