#ifndef __nutGripper_h_
#define __nutGripper_h_

#include "Gripper.h"
#include "EndEffectorImpl.h"

#define NUT_MASS (SCALAR)0.95
#define NUT_INERTIA_X (SCALAR)0.0
#define NUT_INERTIA_Y (SCALAR)0.0
#define NUT_INERTIA_Z (SCALAR)0.0
#define NUT_CENTER_X (SCALAR)1.0
#define NUT_CENTER_Y (SCALAR)0.5
#define NUT_CENTER_Z (SCALAR)-55.0

/*==============================================================
	For Nut gripper
==============================================================*/
/*	status		*/
#define NUT_GRIPPER_STAT_CLOSE	1
#define NUT_GRIPPER_STAT_OPEN	2
#define NUT_GRIPPER_STAT_STOP	4
/*	command		*/
#define NUT_GRIPPER_OPEN		0
#define NUT_GRIPPER_CLOSE		1
#define NUT_GRIPPER_SLOW		2
#define NUT_GRIPPER_STOP		4

class NutGripper : public EndEffectorImpl, public Gripper
{
private:
    SA_ERR err;

public: 
    NutGripper();
    void init(void);
    SA_ERR getError(void);
    void setError(SA_ERR);
    int stat(void) {};
    void output(int val) {};
    void open(void) {};
    void close(void) {};
    void stop(void) {};
};

#endif
