//! @file  Pa10Controller.h
//! @brief PA10 ȥ饤󥿡ե
//
#ifndef _PA10CONTROLLER_H
#define _PA10CONTROLLER_H

#include "DataType.h"
#include "Palib.h"
#include "Pa10Param.h"

class Pa10Controller  {
public:
    // Contructors/Destructor
//    virtual Pa10Controller();
//    virtual ~Pa10Controller();        // Destructor.

    //! @brief PA饤֥
    //
    virtual PA_ERR initSystem(void) = 0;    // Initialize system.
    //
    //! @brief PA饤֥λ
    //
    virtual PA_ERR termSystem(void) = 0;    // Terminate system.
    //
    //! @brief Ф륢ǽˤ
    //
    virtual PA_ERR openArm(void) = 0;        // Open arm.
    //
    //! @brief Ф륢ػߤ
    //
    virtual PA_ERR closeArm(void) = 0;        // Close arm.
    //
    //! @brief 楳ȥ򳫻Ϥ
    //
    virtual PA_ERR startArm(void) = 0;        // Start arm control.
    //
    //! @brief 楳ȥλ
    //
    virtual PA_ERR exitArm(void) = 0;        // Finish arm control.
    //
    //! @brief ֥졼ߤ
    //
    virtual PA_ERR stopArm(WFP) = 0;    // Stop arm control.
    //
    //! @brief ߤ
    //
    virtual PA_ERR suspendArm(WFP) = 0;    // Suspend arm control.
    //
    //! @brief ΰߤ
    //
    virtual PA_ERR restartArm(WFP) = 0;    // Restart arm control.
    //
    //! @brief ƼưԤ
    //
    virtual PA_ERR execAxis(AXIS, const ANGLE&, WFP) = 0;    
                        // Exec each axis motion.
    //
    //! @brief ü֡ɸа֤ꤷ椹
    //
    virtual PA_ERR moveMatrix(MOVEMODE, const MATRIX&, const ANGLE&, WFP) = 0;
    //
    //! @brief οջꤹ
    //
    virtual PA_ERR setPose(const int&) = 0;
                    // Set arm pose: standing/hanging
    //
    //! @brief 顼ΥꥻåȤԤ
    //
    virtual PA_ERR resetControl(void) = 0;    // Reset control.
    //
    //! @brief 顼ֹб顼å
    //
    virtual PA_ERR errorMessage(PA_ERR, unsigned char *) = 0;    // Print error message.
    //
    //! @brief ɸľ⡼ɤꤹ
    //
    virtual PA_ERR modeAxis(void) = 0;        // Each axis control mode.
    //
    //! @brief ɸƼǡꥢ륿ꤹ
    //
    virtual PA_ERR orderAxis(const ANGLE&) = 0;    // Control each axis.
    //
    //! @brief Ʊˤ륿ॢȻ֤ꤹ
    //
    virtual PA_ERR setTimeout(const int&) = 0;    // Set timeout in synch. mode.
    //
    //! @brief 顼ɾ
    //
    //virtual PA_ERR getErrorInfo(int&) = 0;    // Get error info.
    virtual PA_ERR getErrorInfo(void) = 0;    // Get error info.
    //
    //! @brief Ƽ;
    //
    virtual PA_ERR getAngle(ANGLE&) = 0;    // Get all axis angle.
    //
    //! @brief üֻ
    //
    virtual PA_ERR getNOA(MATRIX) = 0;        // GET (N,O,A,P) matrix.
    //
    //! @brief ư׻ξ֤
    //
    virtual PA_ERR getMode(int&) = 0;        // motion control CPU status.
    //
    //! @brief RMRCˤĹ⡼ɤ
    //
    virtual PA_ERR getRedundant(JOUMODE&) = 0;    
                    // redundant axis control mode in RMRC.
    //
    //! @brief ưCPUΥץΥС
    //
    virtual PA_ERR getVersion(float&) = 0;    // motion control program version.
    //
    //! @brief Ʊˤ륿ॢȻ֤
    //
    virtual PA_ERR getTimeout(int&) = 0;    // timeout value.
    //
    //! @brief ®٥⡼ɤꤹ
    //
    virtual PA_ERR modeVelocity(VELMODE vmode, AXIS axis) = 0;
    //
    //! @brief ®٥⡼ɤ®٤ꤹ
    //
    virtual PA_ERR orderVelocity(float speed[]) = 0;
    //
    //! @brief Ĺ⡼ɤꤹ
    //
    virtual PA_ERR modeRedundant(JOUMODE cmode) = 0;
    //
    //! @brief Ĺѥ᥿
    //
    virtual PA_ERR orderRedundant(JOUTYPE jt) = 0;

    //
    //! @brief moveMatrix()callǤ뤫ɤǧ
    //
    virtual BOOL canMoveMatrix(void) = 0;
    //
    //! @brief Ĺͳˤ³٤ꤹ
    //
    virtual void setRestrictAngle(const float[7]) = 0;
    //
    //! @brief Ĺͳˤ³٤
    //
    virtual void getRestrictAngle(float[7]) = 0;
    //! @brief putReferenceConfArm(), putReferenceAngArm()
    //  ưλԤʤ褦ˤ롣δؿ
    //  ٥뤵ȥꥻåȤ롣
    virtual void setNowaitSw(void) = 0;

//    Servo table accessor
    //
    //! @brief ON
    //
    virtual void doSvOn(const int) = 0;
    //
    //! @brief OFF
    //
    virtual void doSvOff(void) = 0;
    //
    //! @brief եȥߥåư
    //
    virtual void doSvLimitter(const int) = 0;
    //
    //! @brief PA10١ɸϤɽ줿ɸϤɸ֡ꤹ
    //
    virtual void putReferenceConfArm(const Frame&) = 0;
    //
    //! @brief ɸϤɽ줿ɸϤɸ®١®٤ꤹ
    //
    virtual void putReferenceVelArm(const float[6]) = 0;
    //
    //! @brief ɸ٤ꤹ
    //
    virtual void putReferenceAngArm(const float[7]) = 0;
    //
    //! @brief ɸ®٤ꤹ
    //
    virtual void putReferenceAngVelArm(const float[7]) = 0;
    //
    //! @brief ᥫ˥륤󥿡եɸϤ鸫ɸϤꤹ
    //
    virtual void setControlCoords(const Frame&) = 0;
    //
    //! @brief ɸϤˤ(PID)ꤹ
    //
    virtual void setFGain(const float[6][3]) = 0;
    //
    //! @brief ɸϤˤʲۡ˥ץ饤ѥ᥿ꤹ
    //
    virtual void setCompParams(const float[6][3]) = 0;
    //
    //! @brief ϳХ祤ƥåˤ륢⡼ɤꤹ
    //
    virtual void setJoyMode(const int) = 0;
    //
    //! @brief ϳХ祤ƥåˤ®楲ꤹ
    //
    virtual void setJoyVGain(const float[2]) = 0;
    //
    //! @brief ϳХ祤ƥåˤ楲ꤹ
    //
    virtual void setJoyFGain(const float[2]) = 0;
    //
    //! @brief ®٥ݥƥ󥷥楲ꤹ
    //
    virtual void setVPGain(const float[2]) = 0;
    //
    //! @brief ®٥ݥƥ󥷥®٤ꤹ
    //
    virtual void setVPVmax(const float[2]) = 0;
    //
    //! @brief ®٥ݥƥ󥷥®٤ꤹ
    //
    virtual void setVPAmax(const float[2]) = 0;
    //
    //! @brief ®٥եȥߥåͤͤꤹ
    //
    virtual void setLimitAbsVelArm(const float[6]) = 0;
    //
    //! @brief ٤Υեȥߥåͤꤹ
    //
    virtual void setLimitAngArm(const float[7][2]) = 0;
    //
    //! @brief ®٥եȥߥåͤͤꤹ
    //
    virtual void setLimitAbsAngVelArm(const float[7]) = 0;
    //
    //! @brief ϳХ󥵤¬ꤵϡ⡼ȤΥեȥߥåͤͤꤹ
    //
    //virtual void setLimitAbsFrc(const float[2]) = 0;
    //
    //! @brief ϳХ󥵤¬ꤵϡ⡼ȤΥեȥߥåͤꤹ
    //
    //virtual void setLimitFrc(const float[6][2]) = 0;
    //! @brief ɸͤꤹ
    //
    virtual void setReferenceForce(const float[6]) = 0;

    //
    //! @brief ܥ⡼ɤ
    //
    virtual int getSvMode(void) = 0;
    //
    //! @brief ߥå⡼ɤ
    //
    virtual int getSvLimitterMode(void) = 0;
    //
    //! @brief PA10١ɸϤɽ줿ᥫ˥륤󥿡եɸϤɸ֡
    //
    virtual void getReferenceConfArm(Frame&) = 0;
    //
    //! @brief ɸϤɽ줿ɸϤɸ®١®٤
    //
    virtual void getReferenceVelArm(float[6]) = 0;
    //
    //! @brief ɸѤ
    //
    virtual void getReferenceAngArm(float[7]) = 0;
    //
    //! @brief ɸ®٤
    //
    virtual void getReferenceAngVelArm(float[7]) = 0;
    //
    //! @brief ᥫ˥륤󥿡եɸϤ鸫ɸϤ
    //
    virtual void getControlCoords(Frame&) = 0;
    //
    //! @brief ɸϤˤ(PID)
    //
    virtual void getFGain(float[6][3]) = 0;
    //
    //! @brief ɸϤˤʲۡ˥ץ饤ѥ᥿
    //
    virtual void getCompParams(float[6][3]) = 0;
    //
    //! @brief ϳХ祤ƥåˤ륢⡼ɤ
    //
    virtual int getJoyMode(void) = 0;
    //
    //! @brief ϳХ祤ƥåˤ®楲
    //
    virtual void getJoyVGain(float[2]) = 0;
    //
    //! @brief ϳХ祤ƥåˤ楲
    //
    virtual void getJoyFGain(float[2]) = 0;
    //
    //! @brief ®٥ݥƥ󥷥楲
    //
    virtual void getVPGain(float[2]) = 0;
    //
    //! @brief ®٥ݥƥ󥷥®٤
    //
    virtual void getVPVmax(float[2]) = 0;
    //
    //! @brief ®٥ݥƥ󥷥®٤
    //
    virtual void getVPAmax(float[2]) = 0;
    //
    //! @brief ®٥եȥߥåͤͤ
    //
    virtual void getLimitAbsVelArm(float[2]) = 0;
    //
    //! @brief ٤Υեȥߥåͤ
    //
    virtual void getLimitAngArm(float[7][2]) = 0;
    //
    //! @brief ®٥եȥߥåͤͤ
    //
    virtual void getLimitAbsAngVelArm(float[7]) = 0;
    //
    //! @brief ϳХ󥵤¬ꤵϡ⡼ȤΥեȥߥåͤͤ
    //
    // virtual void getLimitAbsFrc(float[2]) = 0;
    //
    //! @brief ϳХ󥵤¬ꤵϡ⡼ȤΥեȥߥåͤ
    //
    //virtual void getLimitFrc(float[6][2]) = 0;

    //
    //! @brief ܥͤ
    //
    virtual int getCounter(void) = 0;
    //
    //! @brief ܥ롼׻֤
    //
    virtual int getLoopTime(void) = 0;
    //
    //! @brief ܼ¹Ի֤
    //
    virtual int getExecTime(void) = 0;
    //
    //! @brief ܤξ֤
    //
    virtual int getSvStat(void) = 0;
    //
    //! @brief ᥫ˥륤󥿡եɸϤΰ֡
    //
    virtual void getCurrentConfArm(Frame&) = 0;
    //
    //! @brief Ѥ
    //
    virtual void getCurrentAngArm(float[7]) = 0;
    //
    //! @brief ϳХ󥵤¬ꤵ줿ɸϤˤư줿ϡ⡼Ȥ
    //
    virtual void getFrc(float[6]) = 0;
    //
    //! @brief ϳХ祤ƥå¬ꤵ줿ϡ⡼Ȥ
    //
    virtual void getJoyFrc(float[6]) = 0;

    //
    //! @brief ܤѥ᥿ơ֥ɤ߹
    //
    virtual BOOL readServo(void) = 0;
    //
    //! @brief ܤؤΥѥ᥿ơ֥񤭹
    //
    virtual void writeServo(void) = 0;
};
#endif // _PA10CONTROLLER_H
