/*!
  @file Pa10Param.h  PA10ΤΥѥ᥿ե
*/

/* Copyright 2003 Kosei Kitagaki */
/*
modification history
--------------------
01a,14mar03,kk  first issue
*/

/*!
 *	@brief ܥ
 */
#ifdef VXPALIB
#define SERVO_CYCLE   0.005   // sec
#elif ARTPALIB
//#define SERVO_CYCLE   0.004   // sec
#define SERVO_CYCLE   0.002   // sec
//#define CPU_CLOCK     1266272000.  // Hz for alterf
#define CPU_CLOCK 3215534000. // Hz for coxa
#elif ART
#define SERVO_CYCLE   0.001   // sec
#endif
/*!
 *	@brief ܤǥݡȤǤPA10ο
 */
#define ARM_MAX_NUM		3

/*!
 *	@brief ѤΥߥå
 */
/*	Hard limits
 0: 402774, -402774; 3.089238, -3.089238; 177.000312, -177.000312
 1: 207076, -207076; 1.588253, -1.588253; 91.000203, -91.000203
 2: 395947, -395947; 3.036876, -3.036876; 174.000165, -174.000165
 3: 311752, -311752; 2.391108, -2.391108; 137.000401, -137.000401
 4: 580267, -580267; 4.450593, -4.450593; 255.000172, -255.000172
 5: 375467, -375467; 2.879796, -2.879796; 165.000161, -165.000161
 6: 819200, -819200; 6.283185, -6.283185; 360.000016, -360.000016
*/
#define	A0D	D2R(-170)
#define A0U	D2R(170)
#define	A1D	D2R(-85)
#define A1U	D2R(85)
#define	A2D	D2R(-170)
#define A2U	D2R(170)
#define	A3D	D2R(-130)
#define A3U	D2R(130)
#define	A4D	D2R(-250)
#define A4U	D2R(250)
//#define	A5D	D2R(-160)
//#define A5U	D2R(160)
#define	A5D	D2R(-110)  // Wrench GripperϤ줬
#define A5U	D2R(110)
#define	A6D	D2R(-355)
#define A6U	D2R(355)
/*
#define	A6D	D2R(-180+45)
#define A6U	D2R(180+45)
*/

/*!
 *	@brief wake up modes. PaLibraryheaderƤ
 */
/*
#define JM_ON		0x348
#define JM_OFF		0x349
#define JM_S3ON		0x34A
#define JM_S3DIV	0x34B
#define JM_S3HOLD	0x34C
*/

/*!
 *	@brief ⡼
 */
#define SV_OFF		0x0000
#define SV_ON		0x0001
#define SV_RESET	0x0002
#define SV_TERM         0x0008

#define SV_ON_POSITION	 (0x0010 | SV_ON)
#define SV_ON_VEL	 (0x0020 | SV_ON)
#define SV_ON_ANG_VEL	 (0x0040 | SV_ON)
#define SV_ON_COMP	 (0x0080 | SV_ON)
#define SV_ON_FORCE	 (0x0100 | SV_ON)
#define SV_ON_JOY	 (0x0200 | SV_ON)
#define SV_ON_TOUCH	 (0x0400 | SV_ON)
#define SV_ON_VPOTENTIAL (0x0800 | SV_ON)

#define bitCheck(x,type) (((x)&(type))==(type))

/*!
 *	 @brief 祤ƥå⡼
 */
#define SV_JOY_VEL	0
#define SV_JOY_FRC	1	// All axes

/*!
 *	@brief ߥå⡼
 */
#define SV_CHK_OFF        0x00
#define SV_CHK_ANG	  0x01
#define SV_CHK_FORCE      0x02

/*!
 * 	@brief 祤ƥå⡼ɤˤ륲
 */
#define	DEFAULT_JOY_VEL_FGAIN	40.0   // mm/s/N
#define	DEFAULT_JOY_VEL_MGAIN	1.0    // rad/s/Nm
#define	DEFAULT_JOY_FRC_FGAIN	0.2
#define	DEFAULT_JOY_FRC_MGAIN	0.05

/*!
 * 	@brief ®٥ݥƥ󥷥⡼ɤˤ륲󡢥ߥå
 *      @date 040727
 */
#define	DEFAULT_VP_VGAIN	2.0   // mm/s/mm
#define	DEFAULT_VP_RGAIN	2.0    // rad/s/rad
#define	DEFAULT_VPV_VMAX	250.0   // mm/s
#define	DEFAULT_VPV_RMAX	0.36    // rad/s
#define	DEFAULT_VPA_VMAX	500.0   // mm/s/s
#define	DEFAULT_VPA_RMAX	0.72    // rad/s/s

/*!
 *	@brief ®ٻͤΥߥå (70%) 
 */
#define DEFAULT_LIMIT_VELOCITY	700.0	// [mm/s] (max:1000)
#define DEFAULT_LIMIT_ROTATION	0.55	// [rad/s] (max:0.785)

/*!
 *	@brief ®ٻͤΥߥå (70%)
 */
#define DEFAULT_LIMIT_JOINT_VELOCITY1	0.7	// [rad/s] (max:1.0)
#define DEFAULT_LIMIT_JOINT_VELOCITY2	0.7	// [rad/s] (max:1.0)
#define DEFAULT_LIMIT_JOINT_VELOCITY3	1.4	// [rad/s] (max:2.0)
#define DEFAULT_LIMIT_JOINT_VELOCITY4	1.4	// [rad/s] (max:2.0)
#define DEFAULT_LIMIT_JOINT_VELOCITY5	4.4	// [rad/s] (max:6.28)
#define DEFAULT_LIMIT_JOINT_VELOCITY6	4.4	// [rad/s] (max:6.28)
#define DEFAULT_LIMIT_JOINT_VELOCITY7	4.4	// [rad/s] (max:6.28)

/*! 
 *	@brief ץ饤ѥ᥿
 */
#define DEFAULT_COMP_K0 1000	// [N/m]       
#define DEFAULT_COMP_D0 2000	// [N/(m/s)]   
#define DEFAULT_COMP_M0 40.0	// [kg]		
#define DEFAULT_COMP_K3 10.0	// [Nm/rad]	8.0	1.0
#define DEFAULT_COMP_D3	16.0	// [Nm/(rad/s)]	5.0	0.5
#define DEFAULT_COMP_I3 8.0	// [kgm^2]	0.3	0.3

/*!
 * 	@brief 楲
 */
#define	DEFAULT_FCTRL_P0	0.2    // mm/s/N
//#define	DEFAULT_FCTRL_I0	    // mm/s
#define	DEFAULT_FCTRL_D0	    // mm/s/N/s
#define	DEFAULT_FCTRL_P3	0.05   // rad/s/Nm
//#define	DEFAULT_FCTRL_I3	   // rad/s
#define	DEFAULT_FCTRL_D3	   // rad/s/Nm/s

// EOF
