#ifndef __INCServoTable_h
#define __INCServoTable_h

/* ServoTable.h - servo table definition */
/* Copyright 2003 Kosei Kitagaki */
/*
modification history
--------------------
01a,11mar03, kk  build
*/

#include "DataType.h"
#include "Palib.h"

struct FromServoTable
{
    int counter;
    int loopTime;
    int execTime;
    int svStat;
    int svMode;	  // back

    Frame cConf;
//    float cVel[6];
    float cAng[7];
//    float cAngVel[7];

    Frame rConf;	  // back
    float rVel[6];	  // back
    float rAng[7];	  // back
    float rAngVel[7];     // back  

    float frc[6];

    int joyMode;	  // back
    float joyFrc[6];
};

struct ToServoTable 
{
  int svMode;	  // back
  int svLimitterMode;
  
  Frame rConf;	  // back
  float rVel[6];	  // back
  float rAng[7];	  // back
  float rAngVel[7];     // back
  Frame controlConf;
  float rForce[6];
  
  float fGain[6][3];
  float fCompCalculated[6][3];
  
  float vpGain[2];  // add for VPOTENTIAL mode, 040727
  float vpVmax[2];
  float vpAmax[2];
  
  int joyMode;	  // back
  float joyVGain[2];
  float joyFGain[2];
  
  float limitAbsVel[6];
  float limitAng[7][2];
  float limitAbsAngVel[7];
};

#endif
