/*! @file SingleArm.h
 *  @brief SingleArm 󥿥ե
 *
 *  Ūʥ楯饹Υ󥿥եǤ롣
 *  õʤؿϡWorldɸϤߤToolɸϤ椹롣
 *
 *  @date 2002.11.29: first issue
 */

#ifndef __singlearm_h
#define __singlearm_h
#include "DataType.h"
#include "Constant.h"

typedef enum SA_WAITSW {SA_WAIT, SA_NOWAIT};
typedef long SA_ERR;

class SingleArm {
public:
//! @brief 󥹥󥹤
//    	SingleArm(){};
//    	virtual ~SingleArm(){};

//=============== Basic control ==============
	//! @brief ॷƥ
  	virtual void init(int flag) = 0;
	//! @brief ư
	virtual SA_ERR wake(void) = 0;
	//! @brief ߤ
	virtual SA_ERR stop(void)=0;
	//! @brief ߤ
	virtual SA_ERR sleep(void)= 0;
	//! @brief ॷƥλ
	virtual SA_ERR term(void)= 0;
	//! @brief ξ֤롣
	virtual SA_ERR getStat(int&)= 0;

//=============== Home and Ready ===============
	//! @brief Home ꤹ
	virtual void setHome(const AngleX &ang)= 0;
	//! @brief Home 
	virtual void getHome(AngleX &ang)= 0;
	//! @brief Ready ꤹ
	virtual void setReady(const AngleX &ang)= 0;
	//! @brief Ready 
	virtual void getReady(AngleX &ang)= 0;
	//! @brief Home ư
	virtual SA_ERR home(void)= 0;
	//! @brief Ready ư
	virtual SA_ERR ready(void)= 0;

//=============== Base, Wrist and Tool ===============
	//! @brief Base ɸꤹ
	virtual void setBase(const Frame &conf)= 0;
	//! @brief Base ɸ
	virtual void getBase(Frame &conf)= 0;
	//! @brief Wrist ɸꤹ
	virtual void setWrist(const Frame &conf)= 0;
	//! @brief Wrist ɸ
	virtual void getWrist(Frame &conf)= 0;
	//! @brief Tool ɸꤹ
	virtual void setTool(const Frame &conf)= 0;
	//! @brief Tool ɸ
	virtual void getTool(Frame &conf)= 0;

//=============== Arm control level 1 ===============
	//! @brief WristɸϤθ߰֡롣ExFtSensor饹ɬס
	virtual SA_ERR getCurrentConfWrist(Frame &conf)= 0;

	//! @brief ߰֡
	virtual SA_ERR getCurrentConf(Frame &conf)= 0;
	//! @brief ɸ֡ư
	virtual SA_ERR putReferenceConf(const Frame &conf)= 0;
	//! @brief ɸ֡
	virtual void getReferenceConf(Frame &conf)= 0;
	//! @brief ߰֡
	virtual SA_ERR where(Frame &conf)= 0;	// same as getCurrentConf()
	//! @brief ɸ֡ư
	virtual SA_ERR move(const Frame &conf)= 0; // same as putReferenceConf()
	//! @brief ɸ֡
	virtual void getRef(Frame &conf)= 0;	// same as getReferenceConf()

	//! @brief ToolɸϤˤɸ®١®٤ꤹ
	virtual SA_ERR putReferenceVel(const DoubleVec& conf)= 0;
	//! @brief ToolɸϤˤɸ®١®٤
	virtual void getReferenceVel(DoubleVec& conf)= 0;
	//! @brief ToolɸϤˤ븽®١®٤(̤)
//	virtual void getCurrentVel(DoubleVec& conf)= 0;

	//! @brief ɸ٤ꤹ
	virtual SA_ERR putReferenceAng(const AngleX& ang)= 0;
	//! @brief ɸ٤
	virtual void getReferenceAng(AngleX &ang7)= 0;
	//! @brief ߤδ٤
	virtual SA_ERR getCurrentAng(AngleX &ang7)= 0;

	//! @brief ɸ®٤ꤹ
	virtual SA_ERR putReferenceAngVel(const AngleX &ang)= 0;
	//! @brief ɸ®٤
	virtual void getReferenceAngVel(AngleX &ang)= 0;
	//! @brief ߴ®٤(̤)
//	virtual SA_ERR getCurrentAngVel(AngleX &ang)= 0;
};

#endif
