//! @file  Vec.h
//! @brief ٥ȥɽ饹

#ifndef __VEC_H__
#define __VEC_H__

#include "SubDataType.h"

class Vec {
public:
  Vec();
  Vec(const SCALAR, const SCALAR, const SCALAR);
  Vec(const FLOAT3 pf);
  Vec(const DOUBLE3 pf);

  //! @brief ǤΥե
  inline SCALAR& operator[] (int i) const { 
    if (i < 0 || 3 <= i) 
      cerr << "error ... Vec operator(int) out of range.\n";
    return (SCALAR&)p_[i]; 
  }

  void set(const FLOAT3 pf);
  void get (FLOAT3 pf) const;
  void set(const DOUBLE3 pf);
  void get (DOUBLE3 pf) const;

  void clear ();
  SCALAR norm ();

  Vec& operator+= (Vec);
  Vec& operator-= (Vec);
  Vec& operator*= (SCALAR);
  Vec& operator/= (SCALAR);

  friend Vec operator+ (Vec, Vec);
  friend Vec operator- (Vec, Vec);
  friend SCALAR operator* (Vec a, Vec b); // inner product
  friend Vec operator& (Vec a, Vec b);	  // outer product
  friend Vec operator* (SCALAR, Vec);
  //! @brief ٥ȥѤ֤ 
  friend inline Vec operator * (Vec p, SCALAR f) { return f * p; }
  friend Vec operator/ (Vec a, SCALAR f);

  //! @brief ɽ
  ostream& print () { return cout << *this; };
  void print (char* s);
  friend ostream& operator<< (ostream& to, Vec& p);

protected:
  SCALAR3 p_;
};

class Pos: public Vec
{
public:
  //! @brief 0.0ǥ󥹥󥹤
  Pos():Vec() {};
  //! @brief ͤͿƥ󥹥󥹤
  Pos(const Vec v):Vec(v) {};
  //! @brief ͤͿƥ󥹥󥹤
  Pos(const SCALAR x, const SCALAR y, const SCALAR z):Vec(x,y,z) {};
  //! @brief ͤͿƥ󥹥󥹤
  Pos(const FLOAT3 pf):Vec(pf) {};
  //! @brief ͤͿƥ󥹥󥹤
  Pos(const DOUBLE3 pf):Vec(pf) {};
  //! @brief 0ܤǥե
  inline SCALAR& x() { return (SCALAR&)p_[0]; }
  //! @brief 1ܤǥե
  inline SCALAR& y() { return (SCALAR&)p_[1]; }
  //! @brief 2ܤǥե
  inline SCALAR& z() { return (SCALAR&)p_[2]; }
  Pos& operator= (Vec v);
};

#endif
