#ifndef __INCVxServoTable_h
#define __INCVxServoTable_h

/* VxServoTable.h - servo table definition */
/* Copyright 2003 Kosei Kitagaki */
/*
modification history
--------------------
01a,11mar03, kk  build
*/

#include "DataType.h"
#include "patype.h"

struct FromServoTable
{
	int counter;
	int loopTime;
	int execTime;
	int stat;
	int mode;

	Frame cConf;
	float cVel[6];
	float cAng[7];
	float cAngVel[7];

	Frame rConf;
	float rVel[6];
	float rAng[7];
	float rAngVel[7];

	float frc[6];

	int joyMode;
	float joyFrc[6];
};

struct ToServoTable 
{
	int mode;
	int limitterMode;

	Frame rConf;
	float rVel[6];
	float rAng[7];	
	float rAngVel[7];

	float fGain[6][3];

	int joyMode;
	float joyVGain[2];
	float joyFGain[2];

	Frame limitConf[2];
	float limitAbsVel[2];
	float limitAng[7][2];
	float limitAbsAngVel[7];
	float limitAbsFrc[2];
	float limitFrc[6][2];
};

#endif
