/* VxSharedTable.h - shared buffer table controller */
/* Copyright 2003 Kosei Kitagaki */
/*
modification history
--------------------
02z,11mar03,kk	for gcc 2.7 (static values for template are not available)
02a,11mar03,kk	make Creator which manage multiple tables of same type
01b,10mar03,kk  style refined
01a,27feb03,kk  written
*/

#ifndef __VXSHAREDTABLE_INC__
#define __VXSHAREDTABLE_INC__

#if (__GNUC__ == 2) && (__GNUC_MINOR__ == 7)

#ifndef BOOL
typedef int BOOL;
#endif

#ifndef TRUE
#define TRUE (1)
#define FALSE (0)
#endif

#ifndef NULL
#define NULL (0)
#endif

#include "VxServoTable.h"

#define MAX_TABLE 10

//	fromServoTable

class SharedTable_FromServoTable
{
public:
	void writeSharedTable(FromServoTable* theTable);
	BOOL readSharedTable(FromServoTable* theTable);
	int statSharedTable();

protected:
	static SharedTable_FromServoTable* instanceSharedTable();
	SharedTable_FromServoTable();

private:
	static SharedTable_FromServoTable* mySharedTable = NULL;
	int dataAvailable;
	FromServoTable tbl[2];
};


//	class SharedTableCreator

class SharedTableCreator_FromServoTable : public SharedTable_FromServoTable
{
  public:
	static SharedTable_FromServoTable* createSharedTable(int n);

  protected:
	SharedTableCreator();

  private:
	static SharedTableCreator_FromServoTable* mySharedTableCreator = NULL;
	static SharedTable_FromServoTable* mySharedTables[MAX_TABLE];
};

//	toServoTable

class SharedTable_ToServoTable
{
public:
	void writeSharedTable(ToServoTable* theTable);
	BOOL readSharedTable(ToServoTable* theTable);
	int statSharedTable();

protected:
	static SharedTable_ToServoTable* instanceSharedTable();
	SharedTable_ToServoTable();

private:
	static SharedTable_ToServoTable* mySharedTable = NULL;
	int dataAvailable;
	ToServoTable tbl[2];
};


//	class SharedTableCreator

class SharedTableCreator_ToServoTable : public SharedTable_ToServoTable
{
  public:
	static SharedTable_ToServoTable* createSharedTable(int n);

  protected:
	SharedTableCreator();

  private:
	static SharedTableCreator_ToServoTable* mySharedTableCreator = NULL;
	static SharedTable_ToServoTable* mySharedTables[MAX_TABLE];
};

#endif
#endif
// EOF
