#ifndef __wrenchGripper_h_
#define __wrenchGripper_h_

#include "Gripper.h"
#include "EndEffectorImpl.h"

#define WRENCH_MASS (SCALAR)0.95
#define WRENCH_INERTIA_X (SCALAR)0.0
#define WRENCH_INERTIA_Y (SCALAR)0.0
#define WRENCH_INERTIA_Z (SCALAR)0.0
#define WRENCH_CENTER_X (SCALAR)1.0
#define WRENCH_CENTER_Y (SCALAR)0.5
#define WRENCH_CENTER_Z (SCALAR)-55.0

/*==============================================================
	For Wrench gripper
==============================================================*/
/*	status		*/
#define WRENCH_GRIPPER_STAT_CLOSE	1
#define WRENCH_GRIPPER_STAT_OPEN	2
#define WRENCH_GRIPPER_STAT_STOP	4
/*	command		*/
#define WRENCH_GRIPPER_OPEN		0
#define WRENCH_GRIPPER_CLOSE		1
#define WRENCH_GRIPPER_SLOW		2
#define WRENCH_GRIPPER_STOP		4

class WrenchGripper : public EndEffectorImpl, public Gripper
{
private:
    SA_ERR err;

public: 
    WrenchGripper();
    void init(void);
    SA_ERR getError(void);
    void setError(SA_ERR);
    int stat(void) {};
    void output(int val) {};
    void open(void) {};
    void close(void) {};
    void stop(void) {};
};

#endif
