/*!
*  @file  AngleX.h
*  @brief ٥٥ȥɽ饹
*/

#ifndef __ANGLEX_H__
#define __ANGLEX_H__

#include "SubDataType.h"

class Angle7;

/*!
*  @class AngleX
*  @brief ٥٥ȥɽ饹
*/
class AngleX {
public:
  AngleX(const int);
  AngleX(const AngleX&);
  ~AngleX();

  //! @brief ǤΥե
  inline float& operator[] (int i) { 
    if (i < 0 || dimension_ <= i) 
      cerr << "error ... AngleX operator(int) out of range.\n";
    return (float&)angle_[i]; 
  }
  int getDimension(void) { return dimension_; };

  void clear(void);
  AngleX& operator= (const AngleX&);
  AngleX& operator+= (const AngleX&);
  AngleX& operator-= (const AngleX&);
  AngleX& operator*= (const SCALAR&);
  AngleX& operator/= (const SCALAR&);

  friend AngleX operator+ (AngleX&, AngleX&);
  friend AngleX operator- (AngleX&, AngleX&);
  friend AngleX operator* (AngleX&, SCALAR);
  friend AngleX operator* (SCALAR, AngleX&);
  friend AngleX operator/ (AngleX&, SCALAR);

  //! @brief ɽ
  ostream& print () { return cout << *this; };
  void print (char* s);
  friend ostream& operator<< (ostream& to, AngleX& p);

protected:
  AngleX();
  int dimension_;
  float *angle_;
};

class Angle7: public AngleX
{
public:
  Angle7();
  Angle7(const FLOAT7&);
  Angle7(const Angle7& source);
  Angle7& operator= (const AngleX&);
  void set(const FLOAT7);
  void get(FLOAT7) const;
};

/*
class Angle6: public AngleX
{
public:
  Angle6();
  Angle6(const FLOAT6&);
  Angle6(const Angle6& source);
  Angle6& operator= (const AngleX&);
  void set(const FLOAT6);
  void get(FLOAT6);
};
*/

#endif
