#if !defined(AFX_FRAME_H__31DFDA43_7494_11D3_B0B9_00E0189022E0__INCLUDED_)
#define AFX_FRAME_H__31DFDA43_7494_11D3_B0B9_00E0189022E0__INCLUDED_

/*!
*  @file  Frame.h
*  @brief Frame饹
*
*  Copyright 2002 Kosei Kitagaki 
*/

#include "SubDataType.h"
#include "Matrix3x3.h"
#include "Vec.h"

class Frame {
public:
  Frame();
  Frame(const Frame&);
  Frame(const Matrix3x3& mat, const Vec& vec);

/*   Frame& clear(void); */
  Frame& init(void);
  Frame& clearPos(void);
  
  //! @brief ֥٥ȥǥե
  inline SCALAR& x(void) { return (SCALAR&)vector[0]; }
  //! @brief ֥٥ȥǥե
  inline SCALAR& y(void) { return (SCALAR&)vector[1]; }
  //! @brief ֥٥ȥǥե
  inline SCALAR& z(void) { return (SCALAR&)vector[2]; }
  //! @brief 
  void setElement(int i, int j, float element) { matrix.setElement(i, j, element); };
  //! @brief ž
  RotationMatrix getRotationMatrix(void) const { return matrix; };
  //! @brief ֥٥ȥ
  Pos getPositionVector(void) const { return vector; };

  //! @brief žꤹ
  Frame& setRotationMatrix(const RotationMatrix&);
  //! @brief ֥٥ȥꤹ
  Frame& setPositionVector(const Pos&);

  //! @brief žΥե󥹤
  //RotationMatrix& getRefRotationMatrix(void) { return matrix; };
  //! @brief ֥٥ȥΥե󥹤
  //Pos& getRefVector(void) { return vector; };

  Frame& initRotate (Vec R);	
	// R is a vector of angle-axis and its length means the rotation angle
  Vec getRotationAxis();

/***************************************
 *	transform
 */
  Frame inverse(void) ;

  Frame getRotX(const SCALAR theta); // get rotated frame with fixing the origin
  Frame getRotY(const SCALAR theta);
  Frame getRotZ(const SCALAR theta);
  Frame getTranslate(const SCALAR x, const SCALAR y, const SCALAR z); 
				   	// get translated frame

  Frame& rotX(const SCALAR theta);	// self-rotation with fixing the origin
  Frame& rotY(const SCALAR theta);
  Frame& rotZ(const SCALAR theta);
  Frame& transX(const SCALAR x);	// self-translation
  Frame& transY(const SCALAR y);
  Frame& transZ(const SCALAR z);
  Frame& translate(const SCALAR x, const SCALAR y, const SCALAR z);
	 				// self-translation
  Frame& translate(const Vec p);	// self-translation

  Frame& operator=(Frame);
  Frame& operator*=(const Frame);
  Frame& operator+=(const Vec);
  Frame& operator-=(const Vec);
  friend Frame operator*(const Frame&, const Frame&);
  friend Vec operator*(const Frame&, const Vec&);
  friend Frame operator+(const Frame&, const Vec&);
  friend Frame operator-(const Frame&, const Vec&);

  void print(LPTSTR s);
  friend ostream& operator<< (ostream& to, const Frame& f);
  ostream& print(ostream& to, char *s);
  //! @brief ɽ
  ostream& print() { return cout << *this; }
//  ostream& print(LPTSTR s) { return print (cout, s); }

protected:
  RotationMatrix matrix; // r_
  Pos vector; // m_
};

#endif // !defined(AFX_FRAME_H__31DFDA43_7494_11D3_B0B9_00E0189022E0__INCLUDED_)
