// -*- C++ -*-
/*!
 * @file slidercomp.cpp
 * @brief Called by tk_slider
 * @date $Date$
 *
 * $Id$
 */

#include <rtm/Manager.h>
#include <iostream>
#include <string>
#include "slider.h"
#include "tcl.h"

#define BUFSIZE 1024
#define RERROR \
 { Tcl_SetResult(interp,ereason,TCL_STATIC); return TCL_ERROR; }

using namespace std;

static char ereason[BUFSIZE];

RTC::Manager* g_mgr;

extern "C" {
  class SliderSvc
    : public ACE_Task<ACE_MT_SYNCH>
  {
  public:
    enum DATA_NUM {
      data_num = 6
    };

    int svc(void);
    int open(void *) {
      activate();
      return 0;
    }
  };

  SliderSvc g_SliderSvc;

  int SetDataProc(ClientData data, Tcl_Interp* interp, int argc, char* argv[]);
  int Slidercomp_Init(Tcl_Interp* interp);

  int SliderSvc::svc(void)
  {
    g_mgr->runManager();
    return 0;
  }
  

  void MyModuleInit(RTC::Manager* manager)
  {
    sliderInit(manager);

    // Create a component
    comp = (slider *)manager->createComponent("slider");
    
    return;
  }

  int Slidercomp_Init(Tcl_Interp* interp)
  {
    Tcl_CreateCommand(interp, "SetData", (Tcl_CmdProc *)SetDataProc, NULL, NULL);

    char *array[] = {"", "-f", "./rtc.conf"};

    // Initialize manager
    g_mgr = RTC::Manager::init(3,array);

    g_mgr->init(3,array);

    // Set module initialization proceduer
    // This procedure will be invoked in activateManager() function.
    g_mgr->setModuleInitProc(MyModuleInit);
    
    // Activate manager and register to naming service
    g_mgr->activateManager();
    
    sleep(1);
    
    g_SliderSvc.open(0);
    sleep(1);

    return TCL_OK;
  }

  int SetDataProc(ClientData data, Tcl_Interp* interp,
		  int argc, char* argv[])
  {
    vector<float> v_data(SliderSvc::data_num);
    for (int i = 0; i < SliderSvc::data_num; i++) {
      v_data[i] = atof(argv[(i+1)]);
    }

    comp->set_data(v_data);

    return TCL_OK;
  }
}
