// -*- C++ -*-
/*!
 * @file  slider.h
 * @brief Slider component
 * @date  $Date$
 *
 * $Id$
 */

#ifndef SLIDER_H
#define SLIDER_H

#include <rtm/Manager.h>
#include <rtm/DataFlowComponentBase.h>
#include <rtm/CorbaPort.h>
#include <rtm/DataInPort.h>
#include <rtm/DataOutPort.h>
#include <rtm/idl/BasicDataTypeSkel.h>

#include <vector>

using namespace RTC;

class slider
  : public RTC::DataFlowComponentBase
{
 public:
  slider(RTC::Manager* manager);
  ~slider();
  
  enum DATA_SIZE {
    d_size = 6
  };

  // The activated action (Active state entry action)
  // former rtc_active_entry()
  virtual RTC::ReturnCode_t onActivated(RTC::UniqueId ec_id);

  // The execution action that is invoked periodically
  // former rtc_active_do()
  virtual RTC::ReturnCode_t onExecute(RTC::UniqueId ec_id);

  void set_data(std::vector<float> data);

protected:
  // DataOutPort declaration
  TimedFloatSeq m_Gain;
  OutPort<TimedFloatSeq> m_GainOut;

 private:
  int dummy;

};

static slider *comp;

extern "C"
{
  void sliderInit(RTC::Manager* manager);
};

#endif // SLIDER_H
